---
title: HTMLMediaElement.play()
slug: Web/API/HTMLMediaElement/play
tags:
  - API
  - Audio
  - HTMLMediaElement
  - Interface
  - Media
  - Method
  - Reference
  - Video
  - play
---
<div>{{APIRef("HTML DOM")}}</div>

<p><span class="seoSummary">The {{domxref("HTMLMediaElement")}} <code><strong>play()</strong></code> method attempts to begin playback of the media. It returns a {{jsxref("Promise")}} which is resolved when playback has been successfully started.</span> Failure to begin playback for any reason, such as permission issues, result in the promise being rejected.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>promise</em> = <em>HTMLMediaElement</em>.play();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} which is resolved when playback has been started, or is rejected if for any reason playback cannot be started.</p>

<div class="note">
<p><strong>Note:</strong> Older browsers may not return a value from <code>play()</code>.</p>
</div>

<h3 id="Exceptions">Exceptions</h3>

<p>The promise's <strong>rejection handler</strong> is called with an exception name passed in as its sole input parameter (as opposed to a traditional exception being thrown). Possible errors include:</p>

<dl>
 <dt><code>NotAllowedError</code></dt>
 <dd>The user agent (browser) or operating system doesn't allow playback of media in the current context or situation. This may happen, for example, if the browser requires the user to explicitly start media playback by clicking a "play" button.</dd>
 <dt><code>NotSupportedError</code></dt>
 <dd>The media source (which may be specified as a {{domxref("MediaStream")}}, {{domxref("MediaSource")}}, {{domxref("Blob")}}, or {{domxref("File")}}, for example) doesn't represent a supported media format.</dd>
</dl>

<p>Other exceptions may be reported, depending on browser implementation details, media player implementation, and so forth.</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>Although the term "autoplay" is usually thought of as referring to pages that immediately begin playing media upon being loaded, web browsers' autoplay policies also apply to any script-initiated playback of media, including calls to <code>play()</code>.</p>

<p>If the {{Glossary("user agent")}} is configured not to allow automatic or script-initiated playback of media, calling <code>play()</code> will cause the returned promise to be immediately rejected with a <code>NotAllowedError</code>. Web sites should be prepared to handle this situation. For example, a site should not present a user interface that assumes playback has begun automatically, but should instead update their UI based on whether the returned promise is resolved or rejected. See the {{anch("Example", "example")}} below for more information.</p>

<div class="note">
<p><strong>Note:</strong> The <code>play()</code> method may cause the user to be asked to grant permission to play the media, resulting in a possible delay before the returned promise is resolved. Be sure your code doesn't expect an immediate response.</p>
</div>

<p>For even more in-depth information about autoplay and autoplay blocking, see our article <a href="/en-US/docs/Web/Media/Autoplay_guide">Autoplay guide for media and Web Audio APIs</a>.</p>

<h2 id="Example">Example</h2>

<p>This example demonstrates how to confirm that playback has begun and how to gracefully handle blocked automatic playback:</p>

<pre class="brush: js">let videoElem = document.getElementById("video");
let playButton = document.getElementById("playbutton");

playButton.addEventListener("click", handlePlayButton, false);
playVideo();

async function playVideo() {
  try {
    await videoElem.play();
    playButton.classList.add("playing");
  } catch(err) {
    playButton.classList.remove("playing");
  }
}

function handlePlayButton() {
  if (videoElem.paused) {
    playVideo();
  } else {
    videoElem.pause();
    playButton.classList.remove("playing");
  }
}</pre>

<p>In this example, playback of video is toggled off and on by the <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/async_function">async</a></code> <code>playVideo()</code> function. It tries to play the video, and if successful sets the class name of the <code>playButton</code> element to <code>"playing"</code>. If playback fails to start, the <code>playButton</code> element's class is cleared, restoring its default appearance. This ensures that the play button matches the actual state of playback by watching for the resolution or rejection of the {{jsxref("Promise")}} returned by <code>play()</code>.</p>

<p>When this example is executed, it begins by collecting references to the {{HTMLElement("video")}} element as well as the {{HTMLElement("button")}} used to toggle playback on and off. It then sets up an event handler for the {{event("click")}} event on the play toggle button and attempts to automatically begin playback by calling <code>playVideo()</code>.</p>

<p>You can <a href="https://media-play-promise.glitch.me/">try out or remix this example in real time on Glitch</a>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'embedded-content.html#dom-media-play', 'play()')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition; living specification.</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C','embedded-content-0.html#dom-media-play','play()')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<div class="note">
<p><strong>Note:</strong> The WHATWG and W3C versions of the specification differ (as of August, 2018) as to whether this method returns a {{jsxref("Promise")}} or nothing at all, respectively.</p>
</div>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLMediaElement.play")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Media">Web media technologies</a></li>
 <li>Learning: <a href="/en-US/docs/Learn/HTML/Multimedia_and_embedding/Video_and_audio_content">Video and audio content</a></li>
 <li><a href="/en-US/docs/Web/Media/Autoplay_guide">Autoplay guide for media and Web Audio APIs</a></li>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
